{{
**********************************
* jvmEngine - executes bytecodes *
**********************************
}}


CON
  'first 64
  Jem_NOP               = $00
  Jem_ICONST_M1         = $01
  Jem_ICONST_0          = $02
  Jem_ICONST_1          = $03
  Jem_ICONST_2          = $04
  Jem_ICONST_3          = $05
  Jem_ICONST_4          = $06
  Jem_ICONST_5          = $07
  Jem_BIPUSH            = $08
  Jem_SIPUSH            = $09
  Jem_ILOAD             = $0A
  Jem_ILOAD_0           = $0B
  Jem_ILOAD_1           = $0C
  Jem_ILOAD_2           = $0D
  Jem_ILOAD_3           = $0E
  Jem_ISTORE            = $0F
  Jem_ISTORE_0          = $10
  Jem_ISTORE_1          = $11
  Jem_ISTORE_2          = $12
  Jem_ISTORE_3          = $13
  Jem_IFEQ              = $14
  Jem_IFNE              = $15
  Jem_IFLT              = $16
  Jem_IFLE              = $17
  Jem_IFGT              = $18
  Jem_IFGE              = $19
  Jem_IF_ICMPEQ         = $1A
  Jem_IF_ICMPNE         = $1B
  Jem_IF_ICMPLT         = $1C
  Jem_IF_ICMPGE         = $1D
  Jem_IF_ICMPGT         = $1E
  Jem_IF_ICMPLE         = $1F
  Jem_IF_ACMPEQ         = $20
  Jem_IF_ACMPNE         = $21
  Jem_IRETURN           = $22
  Jem_RETURN            = $23
  Jem_INVOKEVIRTUAL     = $24
  Jem_INVOKESTATIC      = $25
  Jem_GETSTATIC         = $26
  Jem_PUTSTATIC         = $27
  Jem_POP               = $28
  Jem_POP2              = $29
  Jem_DUP               = $2A
  Jem_DUP_X1            = $2B
  Jem_DUP_X2            = $2C
  Jem_DUP2              = $2D
  Jem_DUP2_X1           = $2E
  Jem_DUP2_X2           = $2F
  Jem_SWAP              = $30
  Jem_IADD              = $31
  Jem_ISUB              = $32
  Jem_INEG              = $33
  Jem_IOR               = $35
  Jem_ISHL              = $37
  Jem_ISHR              = $39
  Jem_IUSHR             = $3B
  Jem_IAND              = $3D
  Jem_IXOR              = $3F
  Jem_I2B               = $41
  Jem_GOTO              = $43
  Jem_INVOKEINTERFACE   = $45
  Jem_ARRAYLENGTH       = $47
  Jem_ATHROW            = $49
  Jem_CHECKCAST         = $4B
  'next 64
  Jem_INSTANCEOF        = $4D
  Jem_WIDE              = $4F
  Jem_IINC              = $51
  Jem_GETFIELD          = $53
  Jem_PUTFIELD          = $55
  Jem_NEW               = $57
  Jem_NEWARRAY          = $59
  Jem_ANEWARRAY         = $5B
  Jem_IALOAD            = $5D
  Jem_IASTORE           = $5F
  Jem_BALOAD            = $61
  Jem_BASTORE           = $63
  Jem_LDC               = $65
  Jem_LDC_W             = $67
  Jem_LDC2_W            = $69
  Jem_IMUL              = $6B
  Jem_IDIV              = $6D
  Jem_IREM              = $6F
  Jem_JSR               = $71
  Jem_RET               = $73
  Jem_TABLESWITCH       = $75
  Jem_LOOKUPSWITCH      = $77


OBJ

  jd:            "jvmDataAsm" 'jvm memory access object


VAR

  long  HandlerCog

                              
PUB start(addrJvmVars, addrJemCode)

  stop
  PtrJvmVars := addrJvmVars
  PtrJemCode := addrJemCode
  PtrJemCodeJmpTable := @JemCodeJmpTable
  
  HandlerCog := cognew(@handlerEntry, 0) + 1


PUB stop

  if HandlerCog
    cogstop(HandlerCog~ - 1)

{
      Jem_IADD:            jMath.jb_iadd
      Jem_ISUB:            jMath.jb_isub
      Jem_INEG:            jMath.jb_ineg
      Jem_IOR:             jLogic.jb_ior
      Jem_ISHL:            jLogic.jb_ishl
      Jem_ISHR:            jLogic.jb_ishr
      Jem_IUSHR:           jLogic.jb_iushr
      Jem_IAND:            jLogic.jb_iand
      Jem_IXOR:            jLogic.jb_ixor
      Jem_I2B:             jConvert.jb_i2b
      Jem_GOTO:            jCompareJump.jb_goto
      Jem_INVOKEINTERFACE: 'not used by linker
      Jem_ARRAYLENGTH:     jArray.jb_arraylength
      Jem_ATHROW:          jException.jb_athrow
      Jem_CHECKCAST:       jObject.jb_checkcast
      other:

  else
    case jemcode
      Jem_INSTANCEOF:      jObject.jb_instanceof
      Jem_WIDE:            'not used by linker
      Jem_IINC:            jStore.jb_iinc
      Jem_GETFIELD:        jObject.jb_getfield
      Jem_PUTFIELD:        jObject.jb_putfield
      Jem_NEW:             jObject.jb_new
      Jem_NEWARRAY:        jArray.jb_newarray
      Jem_ANEWARRAY:       jArray.jb_anewarray
      Jem_IALOAD:          jArray.jb_iaload
      Jem_IASTORE:         jArray.jb_iastore
      Jem_BALOAD:          jArray.jb_baload
      Jem_BASTORE:         jArray.jb_bastore
      Jem_LDC:             jConst.jb_ldc
      Jem_LDC_W:           jConst.jb_ldc_w
      Jem_LDC2_W:          'not used by linker
      Jem_IMUL:            jMath.jb_imul
      Jem_IDIV:            jMath.jb_idiv
      Jem_IREM:            jMath.jb_irem
      Jem_JSR:             jSubReturn.jb_jsr
      Jem_RET:             jSubReturn.jb_ret
      Jem_TABLESWITCH:     jCompareJump.jb_tableswitch
      Jem_LOOKUPSWITCH:    jCompareJump.jb_lookupswitch
      other:
  return -1
}  

DAT
{{
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
                        A S S E M B L Y   S E C T I O N

}}
handlerEntry            org     0

sendReady               mov     Tmp,PtrJemCode
                        cmp     _jemcode,#0  wz         'Z = 1 if native function was processed
        if_nz           xor     _jemcode,_jemcode       'otherwise byte code was processed
        if_z            add     Tmp,#1
                        wrbyte  _jemcode,Tmp
nothing2Process                        
:wait4jemcode           rdword  _jemcode,PtrJemCode     'wait for next jemcode or native function
                        tjz     _jemcode,#:wait4jemcode
                        cmp     _jemcode,#$100  wc      'C = 1 if byte code to process
        if_nc           jmp     #doNative               'otherwise a native function to process
                        mov     Tmp,_jemcode
                        sub     Tmp,#Jem_IADD  wc       'C = 0 if byte code is handled by this cog
        if_b            jmp     #:wait4jemcode          'not handled by this cog
                        shl     Tmp,#1                  'jump table entries are words
                        add     Tmp,PtrJemCodeJmpTable
                        rdword  Tmp,Tmp                 'get address of jemcode handler
                        jmp     Tmp                     'handle byte code

{{
############################## JEMCODE HANDLER ################################
}}
{{
_______________________________________________________________________________
function: jb_iadd()
Integer add.

}}
jb_iadd                 call    #popi2l
                        mov     Param2,jvmResult
                        call    #popi2lAgain
                        add     jvmResult,Param2
                        call    #check4Carry
                        jmp     #pushResultAgain                        

{{
_______________________________________________________________________________
function: jb_isub()
Integer subtract.

}}
jb_isub                 call    #popi2l
                        mov     Param2,jvmResult
                        call    #popi2lAgain
                        sub     jvmResult,Param2
                        call    #check4Carry
                        jmp     #pushResultAgain                        

{{
_______________________________________________________________________________
function: jb_ineg()
Integer negate.

}}
jb_ineg                 call    #popi2l
                        neg     Param2,jvmResult wz
                        jmp     #pushParam2

{{
_______________________________________________________________________________
function: jb_ior()
Integer bitwise or.

}}
jb_ior                  call    #pop
                        mov     Param2,jvmResult
                        call    #popAgain
                        or      jvmResult,Param2
                        jmp     #pushResultAgain                        

{{
_______________________________________________________________________________
function: jb_ishl()
Integer shift left.

}}
jb_ishl                 call    #pop
                        mov     Param2,jvmResult
                        call    #popAgain
                        shl     jvmResult,Param2
                        jmp     #pushResultAgain                        

{{
_______________________________________________________________________________
function: jb_ishr()
Integer arithmetic shift right.

}}
jb_ishr                 call    #pop
                        mov     Param2,jvmResult
                        call    #popAgain
                        sar     jvmResult,Param2
pushResultAgain         mov     Param2,jvmResult
pushParam2              call    #pushAgain
incJvmPCEnd             call    #incJvmPC
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_iushr()
Integer logical shift right.

}}
jb_iushr                call    #pop
                        mov     Param2,jvmResult
                        call    #popAgain
                        shr     jvmResult,Param2
                        jmp     #pushResultAgain

{{
_______________________________________________________________________________
function: jb_iand()
Integer bitwise and.

}}
jb_iand                 call    #pop
                        mov     Param2,jvmResult
                        call    #popAgain
                        and     jvmResult,Param2
                        jmp     #pushResultAgain

{{
_______________________________________________________________________________
function: jb_ixor()
Integer bitwise xor.

}}
jb_ixor                 call    #pop
                        mov     Param2,jvmResult
                        call    #popAgain
                        xor     jvmResult,Param2
                        jmp     #pushResultAgain

{{
_______________________________________________________________________________
function: jb_i2b()
Integer to signed byte.

}}
jb_i2b                  call    #pop
                        and     jvmResult,#$FF
                        jmp     #pushResultAgain

{{
_______________________________________________________________________________
function: jb_goto()
Branch.
Description: Execution proceeds at the signed 16-bit offset from the address of
this instruction. The offset is constructed from byte1 and byte2.

}}
jb_goto                 call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE          
                        add     jvmPC,jvmResult         'offset
                        call    #updateJvmPC
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_arraylength()
Get length of array.
Description: The length of the array is determined and replaces aref on the top
of the stack. The aref must be a reference to an array object. 
Note:
A NullPointerException is thrown if the aref is null.

}}
jb_arraylength          call    #pop
                        tjz     jvmResult,#throwNPE
                        mov     Param1,jvmResult        'aref
                        add     Param1,#2
                        call    #readJavaIntBE
                        jmp     #pushResultAgain

{{
_______________________________________________________________________________
function: jb_athrow()
Throw exception or error.
The objectref must be of type reference and must refer to an object that is an
instance of class Throwable or of a subclass of Throwable. It is popped from
the operand stack. The objectref is then thrown by searching the current method
for the first exception handler that matches the class of objectref.
If an exception handler that matches objectref is found, it contains the
location of the code intended to handle this exception. The pc register is
reset to that location, the operand stack of the current frame is cleared,
objectref is pushed back onto the operand stack, and execution continues. 
If no matching exception handler is found in the current frame, that frame is
popped. If the current frame represents an invocation of a synchronized method,
the monitor acquired or reentered on invocation of the method is released or
exited (respectively) as if by execution of a monitorexit instruction.
Finally, the frame of its invoker is reinstated, if such a frame exists, and
the objectref is rethrown.
If no such frame exists, the current thread exits.

}}
jb_athrow               jmp     #sendReady
{
  aref := js.pop 'get objectref
  throwException(aref)
}

{{
_______________________________________________________________________________
function: jb_checkcast()
Make sure object is of given type.
Description: Determines whether the referenced object can be cast to be a
reference to an object of another class. A null object reference can be cast to
any class. Otherwise, the referenced object must be an instance of the expected
class or one of its superclasses. byte1 and byte2 are used to construct an
index into the constant pool of the current class, which is presumed to be a
class name that can be resolved to a class pointer. 
Note: A ClassCastException is thrown if the referenced object cannot be cast to
the expected class.

}}
jb_checkcast            call    #incJvmPC3
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_instanceof()
Determine if an object is of given type and return result.
Description: Determines whether the referenced object can be cast to be a
reference to an object of the expected class. This instruction will overwrite
the object reference with 1 if the object is an instance of the expected class
or one of its superclasses. Otherwise, the object reference is overwritten by
0.

}}
jb_instanceof           call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE          
                        mov     Tmp,jvmResult           'class type
                        call    #pop                    'get instance reference
:chkSuperclass          mov     Param1,jvmResult
                        call    #readJavaIntBE          'get class type for instance
                        cmp     jvmResult,Tmp  wz
        if_z            xor     jvmResult,jvmResult
        if_nz           cmp     jvmResult,MASK_WORD  wz
        if_nz           jmp     #:chkSuperclass
                        add     jvmResult,#1
                        jmp     #incJvmPC3PushAgainEnd
{
  instance := js.pop 'get instance reference
  class := jd.readJavaIntBE(jd.getJvmPC+1) 'class type
  instanceclass := jd.readJavaIntBE(instance) 'get class type for instance
  repeat
    if instanceclass == class
      js.push(1)
      jd.incJvmPC(3)
      return
    else
      instanceclass := jd.readJavaIntBE(instanceclass) 'get superclass of instance
  until instanceclass == $FFFF '$FFFF is superclass of Object class
  js.push(0)
  jd.incJvmPC(3)
}

{{
_______________________________________________________________________________
function: jb_iinc()
Increment local variable by constant.

byte1 is the index of the local variable. byte2 is the signed 1byte value to
add to local variable.

}}
jb_iinc                 call    #getJvmPC
                        add     jvmPC,#1     
                        mov     Param1,jvmPC
                        call    #readJavaByte
                        mov     Tmp,jvmResult           'index
                        shl     Tmp,#1
                        add     jvmPC,#1
                        call    #readJavaByte           
                        call    #b2i
                        mov     Param2,jvmResult        'val
                        call    #getJvmFP
                        mov     Param1,jvmFP
                        add     Param1,Tmp              'fp + (index<<1)
                        call    #readJavaIntBE
                        add     Param2,jvmResult
                        call    #writeJavaIntBE
                        call    #incJvmPCAgain
                        jmp     #sendReady
{
  index := jd.readJavaByte(jd.getJvmPC+1)
  val := jd.readJavaByte(jd.getJvmPC+2)
  val := jc.b2i(val)
  fp := jd.getJvmFP
  val += jd.readJavaIntBE(fp + (index<<1))
  jd.writeJavaIntBE(fp + (index<<1),val)
  jd.incJvmPC(3)
}

{{
_______________________________________________________________________________
function: jb_getfield()
Fetch 32-bit field from object.

}}
jb_getfield             call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE          'get offset
                        mov     Param2,jvmResult
                        call    #pop                    'get reference
                        add     Param2,jvmResult
                        mov     Param1,Param2
                        call    #readJavaIntBEAgain
incJvmPC3PushAgainEnd   mov     Param2,jvmResult
                        call    #pushAgain
incJvmPC3End            call    #incJvmPC3Again
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_putfield()
Set 32-bit field in object.

byte1 is the index of the local variable. byte2 is the signed 1byte value to
add to local variable.

}}
jb_putfield             call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE          'get offset
                        mov     Param2,jvmResult
                        call    #pop                    'get value
                        mov     Tmp,jvmResult
                        call    #popAgain               'get reference
                        add     Param2,jvmResult
                        mov     Param1,Param2
                        mov     Param2,Tmp
                        call    #writeJavaIntBEAgain
                        jmp     #incJvmPC3End

{{
_______________________________________________________________________________
function: jb_new()
Create new object.
Description: offset is used to construct an index into the constant
pool of the current class, which must be a class name that can be resolved to a
class pointer. A new instance of that class is then created, and a reference to
the object is pushed on the stack.

}}
jb_new                  call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE          'get class
                        mov     Param2,jvmResult
                        mov     Param1,Param2
                        add     Param1,#jd#JVM_FIELDS
                        call    #readJavaByteAgain      'get size of non-static non-final variables
                        mov     Tmp,jvmResult
                        mov     Param1,Tmp
                        add     Param1,#jd#JVM_INT_SIZE 'for class reference
                        call    #allocate
                        tjz     jvmResult,#throwOOMErr
                        mov     Param1,jvmResult        'aref
                        call    #writeJavaIntBEAgain
                        add     Param1,#jd#JVM_INT_SIZE
                        mov     Param2,Tmp
                        call    #clearDatabytesAgain         
                        jmp     #incJvmPC3PushAgainEnd
                        
{{
_______________________________________________________________________________
function: jb_newarray()
Allocate new array.
Description: A new array of a specific array type, capable of holding size
elements, is allocated. The result is a reference to the new object. Allocation
of an array large enough to contain size items of the specific array type is
attempted and all elements of the array are initialized to 0. Size represents
the number of elements in the new array and must be an integer. The result is
stored with an internal code that indicates the type of array to allocate.
Possible values for the type of array are as follows:
T_BOOLEAN 4, T_CHAR 5, T_FLOAT 6, T_DOUBLE 7, T_BYTE 8, T_SHORT 9, T_INT 10,
T_LONG 11
Note:
A NegativeArraySizeException is thrown if size is less than 0. 
An OutOfMemoryError is thrown if there is not enough memory to allocate the
array.

byte1 identifies type: 0 for short and int, 1 for boolean, byte and char. 

}}
jb_newarray             call    #pop
                        cmp     jvmResult,#0  wz,wc                    
        if_be           jmp     #throwIAE
                        mov     Tmp,jvmResult           'length
                        call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaByte           
                        mov     Param2,#1
                        sub     Param2,jvmResult        'type
                        mov     Param1,Tmp
                        shl     Param1,Param2
                        mov     jvmHP,Param1            'size
                        add     Param1,#2 * jd#JVM_INT_SIZE 'for class reference and length
                        call    #allocate
                        tjz     jvmResult,#throwOOMErr
                        mov     jvmFP,jvmResult         'aref
                        mov     Param2,Param1           'size + 4
                        mov     Param1,jvmResult
                        call    #clearDatabytesAgain         
                        mov     Param1,#jd#JVM_OBJECT
                        call    #readJavaIntBEAgain
                        mov     Param2,jvmResult        'class
                        mov     Param1,jvmFP
                        call    #writeJavaIntBEAgain
                        mov     Param2,Tmp              'length
                        add     Param1,#jd#JVM_INT_SIZE
                        call    #writeJavaIntBEAgain
                        mov     Param1,jvmFP
                        call    #pushAgain
                        call    #incJvmPC2Again
                        jmp     #sendReady
{
  len := js.pop 'pop length
  if len > 0
    type := jd.readJavaByte(jd.getJvmPC+1)
    size := len*(2-type)
    aref := jh.allocate(size + 4)
    if aref <> 0
      i := 4
      repeat size 'clear array
        jd.writeJavaByte(aref+i,$00)
        i++

      class := jd.readJavaIntBE(jd#JVM_OBJECT)
      jd.writeJavaIntBE(aref+0,class)
      jd.writeJavaIntBE(aref+2,len)
      
      js.push(aref) 'push reference
      jd.incJvmPC(2)
    else
      je.throw(je#kOutOfMemoryError)
  else
    je.throw(je#kIllegalArgumentException)
}

{{
_______________________________________________________________________________
function: jb_anewarray()
Push item from constant pool.

}}
jb_anewarray            jmp     #sendReady


jb_iaload               jmp     #sendReady
jb_iastore              jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_baload()
Load signed byte from array.
Description: The signed byte value at the array index is retrieved, expanded to
an integer, and pushed onto the top of the stack. The aref must be a reference
to an array of signed byte values, and the index into the array must be an
integer.

}}
jb_baload               call    #jb_bax
                        add     Param1,#jd#JVM_INT_SIZE
                        add     Param1,Tmp              'index
                        call    #readJavaByteAgain      'get value
                        call    #b2i                    'as described, but doesn't exist in spin
                        jmp     #pushResultAgain

jb_bax                  call    #popi2l                 'get index            
                        mov     Tmp,jvmResult
                        call    #popAgain               'get reference
                        tjz     jvmResult,#throwNPE
                        mov     Param1,jvmResult
                        add     Param1,#jd#JVM_INT_SIZE
                        call    #readJavaIntBEAgain     'get length
                        cmps    jvmResult,Tmp  wz,wc
        if_a            cmps    Tmp,#0  wc
        if_be           jmp     #throwIOOBE
jb_bax_ret              ret                        
{
  index := js.pop 'get index
  aref := js.pop  'get reference
  if aref <> 0
    elements := jd.readJavaIntBE(aref + 2)
    if index => 0 AND index < elements
      val := jd.readJavaByte(aref + 4 + index)
      js.push(val)    'push value
      jd.incJvmPC(1)
    else
      je.throw(je#kIndexOutOfBoundsException)
  else
    je.throw(je#kNullPointerException)
}

{{
_______________________________________________________________________________
function: jb_bastore()
Store into signed byte array.
Description: An integer is popped off the stack, converted to a signed byte,
and stored in the array at the index. The aref must be a reference to an array
of signed bytes, and the index into the array must be an integer. If the
integer value is too large to be a signed byte, it is truncated.

}}
jb_bastore              call    #pop                    'get value
                        mov     Param2,jvmResult
                        call    #jb_bax
                        add     Param1,#jd#JVM_INT_SIZE
                        add     Param1,Tmp              'index
                        call    #writeJavaByteAgain     'set value
                        jmp     #incJvmPCEnd
{
  val := js.pop   'get value
  index := js.pop 'get index
  aref := js.pop  'get reference
  if aref <> 0
    elements := jd.readJavaIntBE(aref + 2)
    if index => 0 AND index < elements
      jd.writeJavaByte(aref + 4 + index,val)
      jd.incJvmPC(1)
    else
      je.throw(je#kIndexOutOfBoundsException)
  else
    je.throw(je#kNullPointerException)
}

{{
_______________________________________________________________________________
function: jb_ldc()
Push item from constant pool.

}}
jb_ldc                  call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaByte           
jb_ldc_x                mov     Param1,jvmResult        'index
                        shl     Param1,#1
                        mov     jvmVar,#jd#varStringIndex
                        call    #getJvmVar
                        add     Param1,jvmVar           'begin constant pool
                        call    #readJavaIntBE          'get constant
                        mov     Param1,jvmResult
                        call    #push
                        call    #incJvmPC2Again
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_ldc_w()
Push 2-byte item from constant pool.

}}
jb_ldc_w                call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#2
                        call    #readJavaByte           'get index
                        add     jvmPC,#1
                        jmp     #jb_ldc_x

{{
_______________________________________________________________________________
function: jb_imul()
Integer multiply.

}}
jb_imul                 call    #popi2l
                        mov     Param2,jvmResult
                        call    #popi2lAgain
                        mov     Param1,jvmResult
                        call    #mul16x16s
                        call    #check4Carry
                        jmp     #pushResultAgain                        
{
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  w1 := w1 * w2
  jd.clearCarry
  if w1 < -32768 OR w1 > 32767
    jd.setCarry
  js.push(w1)
  jd.incJvmPC(1)
}

{{
_______________________________________________________________________________
function: jb_idiv()
Integer divide.

}}
jb_idiv                 call    #popi2l
                        mov     Param2,jvmResult
                        call    #popi2lAgain
                        mov     Param1,jvmResult
                        call    #div32by16s
                        call    #check4Carry
                        jmp     #pushResultAgain                        
{
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  if w2 <> 0
    w1 := w1 / w2
    jd.clearCarry
    if w1 < -32768 OR w1 > 32767
      jd.setCarry
    js.push(w1)
    jd.incJvmPC(1)
}

{{
############################### JVM FUNCTIONS #################################
The parameters of jvm functions are passed via variables like ParamX where X
is the number of parameter.

}}
{{
_______________________________________________________________________________
function: throwOOMErr()
throw OutOfMemoryError.

uses:   Tmp, jvmTmp
}}
throwOOMErr             mov     Param1,#jd#kOutOfMemoryError
                        jmp     #throw

{{
_______________________________________________________________________________
function: throwIOOBE()
throw IndexOutOfBoundsException.

uses:   Tmp, jvmTmp
}}
throwIOOBE              mov     Param1,#jd#kIndexOutOfBoundsException
                        jmp     #throw

{{
_______________________________________________________________________________
function: throwIAE()
throw IllegalArgumentException.

uses:   Tmp, jvmTmp
}}
throwIAE                mov     Param1,#jd#kIllegalArgumentException
                        jmp     #throw

{{
_______________________________________________________________________________
function: throw()
throw NullPointerException.

uses:   Tmp, jvmTmp
}}
throwNPE                mov     Param1,#jd#kNullPointerException

{{
_______________________________________________________________________________
function: throw(exceptionNumber)
throw one of four runtime exceptions.

param:  Param1 = exceptionNumber
uses:   Tmp, jvmTmp
}}
throw                   mov     Param2,Param1
                        mov     Param1,#jd#JVM_THROW
                        call    #readJavaIntBE
                        mov     Tmp,jvmResult
                        call    #getJvmFP
                        mov     Param1,jvmFP
                        call    #writeJavaIntBEAgain    'write exceptionNumber to arg0 in current frame (eg. istore_0)
                        call    #getJvmPC
                        mov     jvmTmp,jvmPC
                        mov     jvmVar,#jd#varJvmEP
                        call    #updateJvmVar           'remember where exception is thrown
                        mov     Param1,Tmp
                        add     Param1,#jd#JVM_CODE
                        call    #readJavaIntBEAgain
                        mov     jvmPC,jvmResult
                        call    #updateJvmPC            'set new pc to method throwVMException
                        jmp     #sendReady
  
{{
_______________________________________________________________________________
function: doNative(nativeFin)
Execute a native function. Arguments for native functions are either in VP
registers or on the stack. If a native function returns a value it must be
placed on top of the stack.

param:  Param1 = id of function
uses:   jvmTmp
}}
doNative                ror     _jemcode,#8
                        cmp     _jemcode,#14  wz        'isCarry
        if_ne           jmp     #nothing2Process        'not handled by this cog
                        mov     Param1,jvmCarry
                        call    #push
                        xor     _jemcode,_jemcode       'mark that a native function was processed 
                        jmp     #sendReady 

{
  case nm_function
     2: arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_writeObject(arg0,arg1)
     3: arg0 := js.pop
        nm_core_CPU_delay(arg0)
     4: arg1 := js.pop
        arg0 := js.pop
        comm.message(arg0,arg1)
     5: nm_page_
     6: arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_count(arg0,arg1,arg2)
     7: arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        retval := nm_core_CPU_rcTime(arg0,arg1,arg2)
        js.push(retval)
     8: arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        retval := nm_core_CPU_pulseIn(arg0,arg1,arg2)
        js.push(retval)
     9: arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_pulseOut(arg0,arg1)
    10: arg0 := js.pop
        retval := nm_core_CPU_readPin(arg0)
        js.push(retval)
    11: arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_writePin(arg0,arg1)
    12: arg3 := js.pop
        arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        retval := nm_core_CPU_shiftIn(arg0,arg1,arg2,arg3)
        js.push(retval)
    13: arg4 := js.pop
        arg3 := js.pop
        arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_shiftOut(arg0,arg1,arg2,arg3,arg4)
    15: nm_page_
    16: arg0 := js.pop
        nm_core_CPU_uninstall(arg0)
    17: arg0 := js.pop
        nm_core_CPU_install(arg0)
    18: arg0 := js.pop
        nm_core_CPU_nap(arg0)
    19: arg0 := js.pop
        nm_core_CPU_setOutput(arg0)
    20: nm_page_
    21: arg0 := js.pop
        nm_core_CPU_setInput(arg0)
    22: nm_page_
    23: arg0 := js.pop
        retval := nm_core_CPU_readSRAM(arg0)
        js.push(retval)
    24: nm_page_
    25: arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_writeSRAM(arg0,arg1)
    26: nm_page_
    27: arg0 := js.pop
        retval := nm_core_EEPROM_eeRead(arg0)
        js.push(retval)
    28: nm_page_
    29: arg1 := js.pop
        arg0 := js.pop
        nm_core_EEPROM_eeWrite(arg0,arg1)
    30: nm_page_
    31: arg0 := js.pop
        jv.nm_core_Uart_txInit(arg0)
    32: arg0 := js.pop
        jv.nm_core_Uart_rxInit(arg0)
    33: arg0 := js.pop
        retval := jv.nm_core_Uart_rxRead(arg0)
        js.push(retval)
    34: nm_core_Callback_returnTwo
    35: arg0 := js.pop
        jv.nm_core_Timer_init(arg0)
    36: arg0 := js.pop
        jv.nm_core_Timer_latch(arg0)
    37: nm_page_
    38: arg0 := js.pop
        jv.nm_core_PWM_install(arg0)
    39: nm_page_
    40: arg4 := js.pop
        arg3 := js.pop
        arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        jv.nm_core_PWM_updateInternal(arg0,arg1,arg2,arg3,arg4)
    41: nm_page_
    42: arg0 := js.pop
        jv.nm_core_DAC_install(arg0)
    43: nm_page_
    44: arg0 := js.pop
        jv.nm_core_ADC_install(arg0)
    45: nm_page_
    46: retval := comm.getByte
        js.push(retval)
    47: nm_page_
}
doNative_ret            ret

{{
_______________________________________________________________________________
function: allocate(size)
Allocate a block of size bytes from the heap.
Description: Values are stored onto the heap using big endian. The jvmData
methods writeJavaIntBE and readJavaIntBE are used to read/write heap items. The
heap grows downwards. Heappointer points to first free heap byte.

param:  Param1 = size
return: jvmResult = pointer to allocated heap junk
                    or 0 if space couldn't be allocated
uses:   jvmTmp
}}
allocate                call    #getJvmHP
                        mov     jvmResult,#0
                        call    #getJvmSP                            
                        sub     jvmHP,Param1
                        cmp     jvmSP,jvmHP  wc
        if_b            call    #updateJvmHP
        if_b            mov     jvmResult,jvmHP
allocate_ret            ret

{{
_______________________________________________________________________________
function: pop()
Pop word from the stack.

return: jvmResult = value form stack
uses:   jvmTmp, Param1
}}
pop                     call    #getJvmSP
                        call    #decJvmSP2
                        mov     Param1,jvmSP
                        call    #readJavaIntBE
pop_ret                 ret
                        
{{
_______________________________________________________________________________
function: popAgain()
Pop word from the stack if the jvmSP and javaProg is already available.

return: jvmResult = value form stack
uses:   jvmTmp, Param1
}}
popAgain                call    #decJvmSP2
                        mov     Param1,jvmSP
                        call    #readJavaIntBEAgain
popAgain_ret            ret

{{
_______________________________________________________________________________
function: popi2l()
Pop word from the stack and convert it to signed long.

return: jvmResult = value form stack
uses:   jvmTmp, Param1
}}
popi2l                  call    #pop
                        jmp     #popi2lInternal

{{
_______________________________________________________________________________
function: popi2lAgain()
Pop word from the stack if the jvmSP and javaProg is already available.
and convert it to signed long.

return: jvmResult = value form stack
uses:   jvmTmp, Param1
}}
popi2lAgain             call    #popAgain
popi2lInternal          call    #i2l
popi2l_ret
popi2lAgain_ret         ret

{{
_______________________________________________________________________________
function: push(value)
Push word onto the stack.

param:  Param1 = value
uses:   jvmTmp, Param1, Param2
}}
push                    mov     Param2,Param1
                        call    #getJvmSP
                        mov     Param1,jvmSP
                        call    #writeJavaIntBE
                        jmp     #pushEnd
                                                
{{
_______________________________________________________________________________
function: pushAgain(value)
Push word onto the stack if the jvmSP and javaProg is already available.

param:  Param2 = value
uses:   jvmTmp, Param1
}}
pushAgain               mov     Param1,jvmSP
                        call    #writeJavaIntBEAgain
pushEnd                 call    #incJvmSP2
push_ret
pushAgain_ret           ret

{{
_______________________________________________________________________________
function: readJavaByte(address)
read byte value from java program.

param:  Param1 = address
return: jvmResult = value read
uses:   jvmTmp
}}
readJavaByte            call    #getJavaProg
readJavaByteAgain       mov     jvmTmp,Param1
                        add     jvmTmp,javaProg
                        rdbyte  jvmResult,jvmTmp
readJavaByte_ret
readJavaByteAgain_ret   ret

{{
_______________________________________________________________________________
function: writeJavaByte(address, value)
write byte value to java program.

param:  Param1 = address
        Param2 = value
uses:   jvmTmp
}}
writeJavaByteAgain      mov     jvmTmp,Param1
                        add     jvmTmp,javaProg
                        wrbyte  Param2,jvmTmp
writeJavaByte_ret
writeJavaByteAgain_ret  ret

{{
_______________________________________________________________________________
function: readJavaIntBE(address)
read value from java program using big endian.

param:  Param1 = address
return: jvmResult = value read
uses:   jvmTmp
}}
readJavaIntBE           call    #getJavaProg
readJavaIntBEAgain      mov     jvmTmp,Param1
                        add     jvmTmp,javaProg
                        rdbyte  jvmResult,jvmTmp
                        add     jvmTmp,#jd#JVM_INT_SIZE/2
                        shl     jvmResult,#8
                        rdbyte  jvmTmp,jvmTmp
                        or      jvmResult,jvmTmp
readJavaIntBE_ret
readJavaIntBEAgain_ret  ret

{{
_______________________________________________________________________________
function: writeJavaIntBE(address, value)
write value to java program using big endian.

param:  Param1 = address
        Param2 = value
uses:   jvmTmp
}}
writeJavaIntBE          call    #getJavaProg
writeJavaIntBEAgain     mov     jvmTmp,Param1
                        add     jvmTmp,javaProg
                        ror     Param2,#8
                        wrbyte  Param2,jvmTmp
                        add     jvmTmp,#jd#JVM_INT_SIZE/2
                        rol     Param2,#8
                        wrbyte  Param2,jvmTmp
writeJavaIntBE_ret
writeJavaIntBEAgain_ret ret

{{
_______________________________________________________________________________
function: clearDatabytes(address, size)
Clears the data starting from address using given size.

param:  Param1 = address
        Param2 = size
uses:   jvmTmp, jvmVar, Param1, Param2
}}
clearDatabytesAgain     mov     jvmTmp,Param2
                        add     Param1,javaProg
                        shr     jvmTmp,#1               'use word size for clear               
                        shl     jvmTmp,#1
                        sub     Param2,jvmTmp           'calculate rest
                        shr     jvmTmp,#1  wz
                        mov     jvmVar,#0
:clearWord
        if_nz           wrword  jvmVar,Param1
        if_nz           add     Param1,#2
        if_nz           djnz    jvmTmp,#:clearWord
                        test    Param2,#0  wz
        if_nz           wrbyte  jvmVar,Param1
clearDatabytesAgain_ret ret

{{

############################# INTERNAL FUNCTIONS ##############################
}}
{{
_______________________________________________________________________________
function: b2i(value)
value is a signed 1 byte constant: if value < 128 const = value
                                   else const = value | $FF00.

param:  jvmResult = value
return: jvmResult = converted value
}}
b2i                     cmp     jvmResult,#128  wc
        if_nc           or      jvmResult,MASK_WORD_HBYTE
b2i_ret                 ret

{{
_______________________________________________________________________________
function: i2l(value)
value is a signed 2 byte constant: if value < 32768 const = value
                                   else const = value | $FFFF_0000.

param:  jvmResult = value
return: jvmResult = converted value
}}
i2l                     cmp     jvmResult,K32768  wc
        if_nc           or      jvmResult,MASK_LONG_HWORD
i2l_ret                 ret

{{
_______________________________________________________________________________
function: check4Carry(value)
set carry depending on value, 0 if value is positive or $FFFF if value is
negative. 

param:  jvmResult = value
}}
check4Carry             test    jvmResult,K32768  wz    'Z = 1 if positive value
                        muxnz   jvmCarry,MASK_WORD      'otherwise it's negative, set $FFFF                                   
check4Carry_ret         ret

{{
_______________________________________________________________________________
function: mul16x16s(value1, value2)
multiply the given values. 

param:  Param1 = value1
        Param2 = value2
return: jvmResult = result
uses:   jvmTmp, Param1, Param2
}}
_sign1                  long    0
_sign2                  long    0
mul16x16s               mov     jvmResult,#0
                        mov     _sign1,#0
                        mov     _sign2,#0
                        shl     Param1,#1  wc
                        negc    Param1,Param1
        if_c            mov     _sign1,#1
                        shl     Param2,#1  wc
                        shr     Param2,#1
                        negc    Param2,Param2
        if_c            mov     _sign2,#1
                        shl     Param1,#15
                        mov     jvmTmp,#16      
                        shr     Param2,#1  wc
:mloop  if_c            add     Param2,Param1  wc
                        rcr     Param2,#1  wc
                        djnz    jvmTmp,#:mloop
                        cmp     _sign1,_sign2  wz
                        mov     jvmResult,Param2
        if_nz           neg     jvmResult,jvmResult
mul16x16s_ret           ret

{{
_______________________________________________________________________________
function: div32by16s(value1, value2)
divides value1 by value2. 

param:  Param1 = value1
        Param2 = value2
return: jvmResult = result
uses:   jvmTmp, Param1, Param2
}}
div32by16s              shl     Param2,#15              'get divisor into y[30..15] 
                        mov     jvmTmp,#16              'ready for 16 quotient bits 
:dloop                  cmpsub  Param1,Param2  wc       'if y =< x then subtract it, quotient bit into c 
                        rcl     Param1,#1               'rotate c into quotient, shift dividend 
                        djnz    jvmTmp,#:dloop
                        mov     jvmResult,Param1
                        and     jvmResult,MASK_WORD
div32by16s_ret          ret

{{
_______________________________________________________________________________
function: getJavaProg()
get address of java program storage area from main memory.

return: javaProg
uses:   jvmVar
}}
getJavaProg             mov     jvmVar,#jd#varJavaProg
                        call    #getJvmVar
                        mov     javaProg,jvmVar
getJavaProg_ret         ret

{{
_______________________________________________________________________________
function: getJvmEP()
get exception program counter from main memory.

return: jvmEP
uses:   jvmVar
}
getJvmEP                mov     jvmVar,#jd#varJvmEP
                        call    #getJvmVar
                        mov     jvmEP,jvmVar
getJvmEP_ret            ret

{
_______________________________________________________________________________
function: updateJvmEP()
update exception program counter in main memory.

uses:   jvmTmp, jvmVar
}
updateJvmEP             mov     jvmTmp,jvmEP
                        mov     jvmVar,#jd#varJvmEP
                        call    #updateJvmVar
updateJvmEP_ret         ret
}}
{{
_______________________________________________________________________________
function: getJvmFP()
get frame pointer from main memory.

return: jvmFP
uses:   jvmVar
}}
getJvmFP                mov     jvmVar,#jd#varJvmFP
                        call    #getJvmVar
                        mov     jvmFP,jvmVar
getJvmFP_ret            ret

{{
_______________________________________________________________________________
function: updateJvmFP()
update frame pointer in main memory.

uses:   jvmTmp, jvmVar
}}
updateJvmFP             mov     jvmTmp,jvmFP
                        mov     jvmVar,#jd#varJvmFP
                        call    #updateJvmVar
updateJvmFP_ret         ret

{{
_______________________________________________________________________________
function: getJvmHP()
get heap pointer from main memory.

return: jvmHP
uses:   jvmVar
}}
getJvmHP                mov     jvmVar,#jd#varJvmHP
                        call    #getJvmVar
                        mov     jvmHP,jvmVar
getJvmHP_ret            ret

{{
_______________________________________________________________________________
function: updateJvmHP()
update heap pointer in main memory.

uses:   jvmTmp, jvmVar
}}
updateJvmHP             mov     jvmTmp,jvmHP
                        mov     jvmVar,#jd#varJvmHP
                        call    #updateJvmVar
updateJvmHP_ret         ret

{{
_______________________________________________________________________________
function: getJvmPC()
get program counter from main memory.

return: jvmPC
uses:   jvmVar
}}
getJvmPC                mov     jvmVar,#jd#varJvmPC
                        call    #getJvmVar
                        mov     jvmPC,jvmVar
getJvmPC_ret            ret

{{
_______________________________________________________________________________
function: incJvmPC()
increments program counter by 1.

uses:   jvmTmp, jvmVar
}}
incJvmPC                call    #getJvmPC
incJvmPCAgain           add     jvmPC,#1
updateJvmPC             mov     jvmTmp,jvmPC
                        mov     jvmVar,#jd#varJvmPC
                        call    #updateJvmVar
incJvmPC_ret
incJvmPCAgain_ret
incJvmPC2Again_ret
incJvmPC3_ret
incJvmPC3Again_ret
addN2JvmPC_ret
addN2JvmPCAgain_ret
updateJvmPC_ret         ret

{{
_______________________________________________________________________________
function: incJvmPC2()
increments program counter by 2.

uses:   jvmTmp, jvmVar
}}
incJvmPC2Again          add     jvmPC,#2
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: incJvmPC3()
increments program counter by 3.

uses:   jvmTmp, jvmVar
}}
incJvmPC3               call    #getJvmPC
incJvmPC3Again          add     jvmPC,#3
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: addN2JvmPC(diff)
adds given diff to program counter.

param:  jvmTmp = diff to add
uses:   jvmVar
}}
addN2JvmPC              call    #getJvmPC
addN2JvmPCAgain         add     jvmPC,jvmTmp
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: getJvmSP()
get stack pointer from main memory.

return: jvmSP
uses:   jvmVar
}}
getJvmSP                mov     jvmVar,#jd#varJvmSP
                        call    #getJvmVar
                        mov     jvmSP,jvmVar
getJvmSP_ret            ret

{{
_______________________________________________________________________________
function: decJvmSP2()
decrements stack pointer by 2 and updates it in main memory.

uses:   jvmTmp, jvmVar
}}
decJvmSP2               sub     jvmSP,#2
                        jmp     #updateJvmSP

{{
_______________________________________________________________________________
function: incJvmSP2()
increments stack pointer by 2 and updates it in main memory.

uses:   jvmTmp, jvmVar
}}
incJvmSP2               add     jvmSP,#2
updateJvmSP             mov     jvmTmp,jvmSP
                        mov     jvmVar,#jd#varJvmSP
                        call    #updateJvmVar
decJvmSP2_ret
incJvmSP2_ret
updateJvmSP_ret         ret

{{
_______________________________________________________________________________
function: getJvmVar(variable)
get a jvm variable from main memory.

param:  jvmVar = variable to get
return: jvmVar = value of jvm variable
}}
getJvmVar               add     jvmVar,PtrJvmVars
                        rdword  jvmVar,jvmVar
getJvmVar_ret           ret

{{
_______________________________________________________________________________
function: updateJvmVar(variable, value)
updates a jvm variable in main memory with the given value.

param:  jvmVar = variable to update
        jvmTmp = value to set
uses:   jvmVar
}}
updateJvmVar            add     jvmVar,PtrJvmVars
                        wrword  jvmTmp,jvmVar
updateJvmVar_ret        ret


K32768                  long    $8000
MASK_WORD               long    $FFFF
MASK_WORD_HBYTE         long    $FF00
MASK_LONG_HWORD         long    $FFFF_0000
PtrJemCodeJmpTable      long    0-0
PtrJemCode              long    0-0
PtrJvmVars              long    0-0

'                        long    $88338833[26]          'currently 26 longs left
_jemcode                res     1
Param1                  res     1
Param2                  res     1
Tmp                     res     1
jvmResult               res     1
jvmTmp                  res     1
jvmVar                  res     1
javaProg                res     1
'jvmEP                   res     1
jvmFP                   res     1
jvmHP                   res     1
jvmPC                   res     1
jvmSP                   res     1
jvmCarry                res     1
                        fit     $1F0
'
                        
DAT

JemCodeJmpTable         word    (@jb_iadd - @handlerEntry)/4          'Jem_IADD
                        word    (@jb_isub - @handlerEntry)/4          'Jem_ISUB
                        word    (@jb_ineg - @handlerEntry)/4          'Jem_INEG
                        word    0                                     'Jem_$34 not used
                        word    (@jb_ior - @handlerEntry)/4           'Jem_IOR
                        word    0                                     'Jem_$36 not used
                        word    (@jb_ishl - @handlerEntry)/4          'Jem_ISHL
                        word    0                                     'Jem_$38 not used
                        word    (@jb_ishr - @handlerEntry)/4          'Jem_ISHR
                        word    0                                     'Jem_$3A not used
                        word    (@jb_iushr - @handlerEntry)/4         'Jem_IUSHR
                        word    0                                     'Jem_$3C not used
                        word    (@jb_iand - @handlerEntry)/4          'Jem_IAND
                        word    0                                     'Jem_$3E not used
                        word    (@jb_ixor - @handlerEntry)/4          'Jem_IXOR
                        word    0                                     'Jem_$40 not used
                        word    (@jb_i2b - @handlerEntry)/4           'Jem_I2B
                        word    0                                     'Jem_$42 not used
                        word    (@jb_goto - @handlerEntry)/4          'Jem_GOTO
                        word    0                                     'Jem_$44 not used
                        word    (@nothing2Process - @handlerEntry)/4  'Jem_INVOKEINTERFACE not used by linker
                        word    0                                     'Jem_$46 not used
                        word    (@jb_arraylength - @handlerEntry)/4   'Jem_ARRAYLENGTH
                        word    0                                     'Jem_$48 not used
                        word    (@jb_athrow - @handlerEntry)/4        'Jem_ATHROW
                        word    0                                     'Jem_$4A not used
                        word    (@jb_checkcast - @handlerEntry)/4     'Jem_CHECKCAST
                        word    0                                     'Jem_$4C not used
                        word    (@jb_instanceof - @handlerEntry)/4    'Jem_INSTANCEOF
                        word    0                                     'Jem_$4E not used
                        word    (@nothing2Process - @handlerEntry)/4  'Jem_WIDE not used by linker
                        word    0                                     'Jem_$50 not used
                        word    (@jb_iinc - @handlerEntry)/4          'Jem_IINC
                        word    0                                     'Jem_$52 not used
                        word    (@jb_getfield - @handlerEntry)/4      'Jem_GETFIELD
                        word    0                                     'Jem_$54 not used
                        word    (@jb_putfield - @handlerEntry)/4      'Jem_PUTFIELD
                        word    0                                     'Jem_$56 not used
                        word    (@jb_new - @handlerEntry)/4           'Jem_NEW
                        word    0                                     'Jem_$58 not used
                        word    (@jb_newarray - @handlerEntry)/4      'Jem_NEWARRAY
                        word    0                                     'Jem_$5A not used
                        word    (@jb_anewarray - @handlerEntry)/4     'Jem_ANEWARRAY
                        word    0                                     'Jem_$5C not used
                        word    (@jb_iaload - @handlerEntry)/4        'Jem_IALOAD
                        word    0                                     'Jem_$5E not used
                        word    (@jb_iastore - @handlerEntry)/4       'Jem_IASTORE
                        word    0                                     'Jem_$60 not used
                        word    (@jb_baload - @handlerEntry)/4        'Jem_BALOAD
                        word    0                                     'Jem_$62 not used
                        word    (@jb_bastore - @handlerEntry)/4       'Jem_BASTORE
                        word    0                                     'Jem_$64 not used
                        word    (@jb_ldc - @handlerEntry)/4           'Jem_LDC
                        word    0                                     'Jem_$66 not used
                        word    (@jb_ldc_w - @handlerEntry)/4         'Jem_LDC_W:           jConst.jb_ldc_w
                        word    0                                     'Jem_$68 not used
                        word    (@nothing2Process - @handlerEntry)/4  'Jem_LDC2_W not used by linker
                        word    0                                     'Jem_$6A not used
                        word    (@jb_imul - @handlerEntry)/4          'Jem_IMUL
                        word    0                                     'Jem_$6C not used
                        word    (@jb_idiv - @handlerEntry)/4          'Jem_IDIV
                        word    0                                     'Jem_$6E not used
                        word    (@nothing2Process - @handlerEntry)/4  'Jem_IREM:            jMath.jb_irem
                        word    0                                     'Jem_$70 not used
                        word    (@nothing2Process - @handlerEntry)/4  'Jem_JSR:             jSubReturn.jb_jsr
                        word    0                                     'Jem_$72 not used
                        word    (@nothing2Process - @handlerEntry)/4  'Jem_RET:             jSubReturn.jb_ret
                        word    0                                     'Jem_$74 not used
                        word    (@nothing2Process - @handlerEntry)/4  'Jem_TABLESWITCH:     jCompareJump.jb_tableswitch
                        word    0                                     'Jem_$76 not used
                        word    (@nothing2Process - @handlerEntry)/4  'Jem_LOOKUPSWITCH:    jCompareJump.jb_lookupswitch
                        word    0                                     'Jem_$78 not used
'      