{{
********************************
* jvmMain - top object for JVM *
********************************
}}


CON

  'clock settings for spin stamp
  _clkmode = xtal1+pll8x
  _xinfreq = 10_000_000
  'clock settings for propeller board
'  _clkmode = xtal1+pll16x
'  _xinfreq = 5_000_000

  commPort = 1 '0=none, 1=propeller TX/RX, 2=spin stamp SOUT/SIN/ATN


OBJ

  comm:  "jvmCommAsm"   'communication port object
  jd:    "jvmDataAsm"   'jvm memory access object
'  nf:    "jvmNative"    'native functions
  je:    "jvmEngineAsm" 'the bytecode interpreter
  jprog: "jvmJavaProg"  'storage area for java bytecodes (MUST ONLY BE INCLUDED HERE)


PUB main | c
{{ application starts here }}
  comm.start(commPort,true)
  comm.setReset
  repeat 'keep running
    jd.init(jprog.getJavaProgram,jprog#JAVASIZE,commPort)  'initialize jvm registers and pass javaProg properties
    if comm.isReset
      comm.doReset
      comm.clearReset
      repeat
        c := comm.doDebug(2000)
      until c == -1
    else
      'mainloop
      je.start 'stops used cogs before restart
      repeat
        if commPort > 0
          if comm.isReset
            quit
          comm.doDebug(0)     'check for debug commands
        je.doBytecode(commPort > 0) 'execute next bytecode
{
'native functions are handled in PASM
        case c
          0..47: nf.doNative(c)  'invoke a native function
                 jd.incJvmPC(3)  'move to next bytcode
          'add userdefined native functions here
}